## Visual Tracking with Multi-Level Deep Features (MLDF)

### Introduction
This package contains the source code to reproduce the experimental results of MLDF. The source code is mainly written in MATLAB with a modifed Caffe framework.

### Usage

* Supported OS: the source code was tested on 64-bit Ubuntu 14.04 Linux OS, and it should also be executable in other linux distributions.

* Dependencies: 
 * A modified version of [caffe](http://caffe.berkeleyvision.org/) framework (included in the ./MLDF/caffe folder) and all its dependencies. 
 * Cuda enabled GPUs

* Installation: 
 1. Install caffe: we use a modified version of the original caffe framework. Compile the source code in the ./MLDF/caffe directory and the matlab interface following the [installation instruction of caffe](http://caffe.berkeleyvision.org/installation.html).
 2. Download the 16-layer VGG network from https://gist.github.com/ksimonyan/211839e770f7b538e2d8, and put the caffemodel file under the ./MLDF/model directory.
 3. Properly configure the code (see blow), and run ./vot-toolkit/vot2016-workspace/run_experiments.m


### Settings

# 1. We provide both CPU (default) and GPU implementations of our codes, if you want to run our codes in the GPU mode, make changes as follows:
 (1) In ./MLDF/caffe/Makefike.config: comment Line 8
 (2) In ./MLDF/set_tracker_param.m: change Line 7 to "use_gpu=1;"
 (3) In ./MLDF/model/feature_solver.prototxt: change Line 15 to "solver_mode: GPU;"  and uncomment Line 17
 (4) In ./MLDF/model/spn_solver.prototxt: change Line 15 to "solver_mode: GPU" and uncomment Line 17

# 2. To run our codes, the folling pathes should be adjusted based on where you put the codes (we use CODE_ROOT to denot the root directory)
 
 (1). In ./MLDF/set_tracker_param.m: chane Line 2 to "cur_path = [$CODE_ROOT,'/MLDF/'];"
 (2). In ./MLDF/model/feature_solver.prototxt: change Line 1 to "net: '$CODE_ROOT/MLDF/model/feature_net.prototxt' "
 (3). In ./MLDF/model/spn_solver.prototxt: change Line 1 to "net: '$CODE_ROOT/MLDF/model/spn.prototxt' " 
 (4). In ./vot-toolkit/vot2016-workspace/run_experiments.m: change Line 4 to "addpath('$CODE_ROOT/vot-toolkit'); toolkit_path; "
 (5). In ./vot-toolkit/vot2016-workspace/tracker_MLDF.m: change Line 18 to "tracker_command = generate_matlab_command('MLDF_VOT', {'$CODE_ROOT/MLDF/'});"

### Contact
wlj@mail.dlut.edu.cn
xingkong19890806@gmail.com

### Liscense

        Copyright (c) 2016, Lijun Wang
        All rights reserved. 
        Redistribution and use in source and binary forms, with or without modification, are 
        permitted provided that the following conditions are met:
    		* Redistributions of source code must retain the above copyright 
      		  notice, this list of conditions and the following disclaimer.
    		* Redistributions in binary form must reproduce the above copyright 
      		  notice, this list of conditions and the following disclaimer in 
      		  the documentation and/or other materials provided with the distribution
        
        THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
        AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
        IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
        ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 	
        LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
        CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
        SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
        INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
        CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
        ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
        POSSIBILITY OF SUCH DAMAGE.
